if not _G.Handicapper_mod then
	_G.Handicapper_mod = _G.Handicapper_mod or {}
	Handicapper_mod._path = ModPath
	Handicapper_mod._data_path = SavePath .. "handicapper.txt"
	Handicapper_mod._order = {
		["dodge"] = 20, 
		["armor"]= 19, 
		["health"] = 18,
		["ammo"] = 17
	}
	Handicapper_mod._settings = {}
	for name, _ in pairs(Handicapper_mod._order) do
		Handicapper_mod._settings[name] = true
	end
end


function Handicapper_mod:Load()
	local file = io.open(Handicapper_mod._data_path, "r")
	if file then
		local decoded = json.decode(file:read("*all")) or {}
		for k, v in pairs(decoded) do
			Handicapper_mod._settings[k] = v
		end
		file:close()
	end
	self:ToggleDodge()
end

function Handicapper_mod:ToggleDodge()
	if Handicapper_mod._settings.dodge then
			tweak_data.player.damage.DODGE_INIT = 0
		else
			tweak_data.player.damage.DODGE_INIT = -100
	end	
end

function Handicapper_mod:Save()
	local file = io.open(Handicapper_mod._data_path, "w+")
	if file then
		file:write(json.encode(Handicapper_mod._settings))
		file:close()
	end
end

---------------------------------------------- Localization ------------------------------------------------



Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_Handicapper_mod", function(loc)

	for _, filename in pairs(file.GetFiles(Handicapper_mod._path .. "loc/")) do
		local str = filename:match('^(.*).txt$')
		if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
			loc:load_localization_file(Handicapper_mod._path .. "loc/" .. filename)
			break
		end
	end

	loc:load_localization_file(Handicapper_mod._path .. "loc/english.txt", false)
end)







----------------------------------------------- Menu ------------------------------------------------------



Hooks:Add("MenuManagerInitialize", "MenuManagerInitialize_Handicapper_mod", function(menu_manager)

	MenuCallbackHandler.handicapper_mod_main_callback = function(this,item)
		local name = tostring(item._parameters["name"]):gsub("handicapper_mod_","")
		Handicapper_mod._settings[name] = Utils:ToggleItemToBoolean(item)
		if name == "dodge" then
			Handicapper_mod:ToggleDodge()
		end
	end

	MenuCallbackHandler.handicapper_mod_back = function(this, item)
		Handicapper_mod:Save()
	end

	Handicapper_mod:Load()

	-- Main Menu
	Hooks:Add("MenuManagerSetupCustomMenus", "Base_SetupCustomMenus_Json_Handicapper_mod_main_menu", function( menu_manager, nodes )
			MenuHelper:NewMenu( "handicapper_mod_main_menu" )
		end)

	Hooks:Add("MenuManagerBuildCustomMenus", "Base_BuildCustomMenus_Json_Handicapper_mod_main_menu", function( menu_manager, nodes )

			local parent_menu = "lua_mod_options_menu"
			local menu_id = "handicapper_mod_main_menu"
			local menu_name = "handicapper_mod_main_menu_title"
			local menu_desc = "handicapper_mod_main_menu_desc"

			local data = {
				focus_changed_callback = nil,
				back_callback = "handicapper_mod_back",
				area_bg = nil,
			}
			nodes[menu_id] = MenuHelper:BuildMenu( menu_id, data )

			MenuHelper:AddMenuItem( nodes[parent_menu], menu_id, menu_name, menu_desc, nil )

		end)

	Hooks:Add("MenuManagerPopulateCustomMenus", "Base_PopulateCustomMenus_Json_Handicapper_mod_main_menu", function( menu_manager, nodes )

			for name, value in pairs(Handicapper_mod._order) do
				MenuHelper:AddToggle({
					id = "handicapper_mod_".. name,
					title = "handicapper_mod_".. name .. "_title",
					desc = "handicapper_mod_".. name .. "_desc",
					callback = "handicapper_mod_main_callback",
					value = Handicapper_mod._settings[name],
					menu_id = "handicapper_mod_main_menu",
					priority = value,
					localized = true,
				})
			end

		end)
	
end)
